Unit SF21R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF10_p;

function SF21R(X :Real; var IERR :Integer): Real;

implementation

function SF21R(X :Real; var IERR :Integer): Real;
var
N,I :Integer;
P,R,Z,Z1 :Real;
Q,X1 :Extended;
const
D21T43 :Real = 21.43;
SYS001 :Real = 3.1415926535897932384626433832795;
SYS059 :Real = 3.4E38;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
{ Result -    SF21R  FORTRANe }
IERR := 0;
P := 1.0;
if ( X <= D21T43 ) 
 then goto _1;
IERR := 66;
goto _14;
_1:
if ( X < 8.0 ) 
 then goto _2;
R := X;
goto _11;
_2:
if ( X <= (-8.0) ) 
 then goto _9;
X1 := X-2.0;
N := Trunc( X1 );
if ( X1 < 0 ) and ( X1 <> N ) 
 then N := N-1;
R := X1-(N);
if ( N ) < 0
 then goto _6
 else if ( N ) > 0
       then goto _3
       else goto _5;
_3:
for I:=1 to N do
 begin
  P := P*(X-(I));
_4:
 end;
_5:
goto _8;
_6:
if ( N < (-1.0) ) and ( R = 0.0 ) 
 then goto _13;
N := -N;
for I:=1 to N do
 begin
  P := P*(R+(2-I));
_7:
 end;
P := 1.0/P;
_8:
Q := ((((9.382134*R+5.412242E1)*R+3.217500E2)*R+
    8.437441E2)*R+1.949143E3)/((((((R-1.020571E1)*R+
    2.487734E1)*R+9.388405E1)*R-4.893048E2)*R+1.967692E1)*
    R+1.949143E3);
goto _12;
_9:
R := 1.0-X;
N := Trunc( X );
if ( N-X = 0 ) 
 then goto _13;
X1 := Sin(SYS001*X);
P := SYS001;
if ( X1 ) < 0
 then goto _10
 else if ( X1 ) > 0
       then goto _11
       else goto _13;
_10:
P := -P;
X1 := -X1;
_11:
Z := 1.0/R;
Z1 := Z*Z;
Q := Z*((-0.169576483584e-2*Z1+0.79545700470e-1) *Z1+0.113632924908e0)/(Z1+
    1.36359509891e0)+0.918938533205e0+(R-0.5)*Ln(R)-R;
if ( X < 0.0 ) 
 then Q := -Q- Ln(X1);
Q := Exp(Q);
_12:
Result := P*Q;
goto _15;
_13:
IERR := 65;
_14:
UTSF10(IERR,21);
Result := SYS059;
_15:
exit;
end;

end.
